;Program til timer for fjernstyring av kupevarmer vha. mobiltelefon
;Samt alarmsender for innbrudsalarm i bil, ringer opp forhndsprogramert nummer
;av Sondre Danielsen
;Prosessoren's oscillator frekvens skal vre p 1Mhz (1Mhz Krystall)

	LIST    P=16f84

	
_CP_OFF		equ	H'3FFF'			;code protect off
_PWRTE_ON	equ	H'3FFF' 		;Power on timer on
_WDT_OFF	equ	H'3FFB'			;watch dog timer off
_XT_OSC		equ	H'3FFD'			;crystal oscillator
__CONFIG     	_CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
	

porta	equ	5
portb	equ	6
teller1	equ	10		
teller2 equ	11
teller3 equ	12
teller4	equ	13
var1	equ	14	



	bsf	3,5
	movlw	b'11110101'		;setter portb,1,3 til utg porta 
	movwf	5
	bcf	3,5
	clrf	porta
	clrf	var1

;----------- Start --------------

start	bcf	porta,3			;stopper varmeapparat
	bcf	porta,1			;stopper alarm utgang
	btfsc	porta,2			;sjekker om det ringer
	goto	ring
	btfsc	portb,3			;sjekker om det gr en alarm
	call	alarm
	btfss	portb,3			;sjekker om alarminngangen er lav
	bcf	var1,0			;sletter bit som viser at alarmen har vrt aktivert 
	goto	start

;--------- Innringing ------------

ring	call	sekund
	call	sekund
	call	sekund
	call	sekund
	btfss	porta,2			;sjekker om det fortsatt ringer ettr 4 sek.
	goto	start			;hvis ikke gr til start
	bsf	porta,3			;ringer fortsatt, starter varmeapparat
	
	btfsc	portb,4			;sjekker tidsinstilling bryter 1   
	goto	time1
	btfsc	portb,5			;sjekker tidsinstilling bryter 2 
	goto	time2
	btfsc	portb,6			;sjekker tidsinstilling bryter 3 
	goto	time3
	btfsc	portb,7			;sjekker tidsinstilling bryter 4 
	goto	time4
	call	sekund			
	bcf	porta,3			;hvis ingen brytere er satt, stoppes varmeapparetet etter 1 sek.
	goto	start

;----- timer rutiner ----------

time1	movlw	.30			;30 minutter
	movwf	teller4
loop4	call	minutt
	decfsz	teller4
	goto	loop4
	goto	start	

time2	movlw	.60			;1 time
	movwf	teller4
loop5	call	minutt
	decfsz	teller4
	goto	loop5
	goto	start	


time3	movlw	.90			;1 time og 30 minutter
	movwf	teller4
loop6	call	minutt
	decfsz	teller4
	goto	loop6
	goto	start	



time4	movlw	.120			;2 timer
	movwf	teller4
loop7	call	minutt
	decfsz	teller4
	goto	loop7
	goto	start	

;------- alarm rutine -----------

alarm	btfsc	var1,0			;sjekker om alarminngangen har godt lav siden siste alarm		
	return				;hvis ikke sendes ingen ny alarm
	call	sekund2			;venter 2 sekunder
	call	sekund2
	btfss	portb,3			;sjekker om alarminngangen fortsatt er hy
	return				;hvis ikke s returnerer den
	bsf	porta,1			;hvis den fortsatt er hy s gis alarm utg. i 3 sek
	bsf	var1,0			;setter bit for  huske at larmen er sendt
	bcf	porta,3			;stopper varmeapparat
	call	sekund2			
	call	sekund2
	call 	sekund2
	bcf	porta,1			;alarmutgang settes lav
	call	minutt			;venter 1 minutt for  hindre at sty fra telefonen starter varmeapparatet
	goto	start			;gr til start etter alarm signal

;---- venterutine 1 minutt ------

minutt	movlw	.60			;kaller opp 1 sekund rutinen 60 ganger
	movwf	teller3
loop3	call	sekund
	decfsz	teller3
	goto	loop3
	return

;---- venterutine 1 sekund ------

sekund	movlw	.248			;B	248		
	movwf	teller2
loop2	movlw	.251			;A	251
	movwf	teller1
loop1	nop
	decfsz	teller1
	goto	loop1
	decfsz	teller2
	goto	loop2
	btfsc	portb,3			;sjekker om alarminngangen er hy
	goto	al			
	return

al	btfss	porta,1			;sjekker om alarmutgangen allerede er hy
	call	alarm			;hvis ikke aktiver alarm
	return



;---- venterutine 1 sekund uten sjekking av alarminngang ------

sekund2	movlw	.248			;B	248		
	movwf	teller2
loop9	movlw	.251			;A	251
	movwf	teller1
loop8	nop
	decfsz	teller1
	goto	loop8
	decfsz	teller2
	goto	loop9			
	return

	END
